﻿//utlity methods and some application-wide helpers, like "show announcement bar", or "init 'location' custom fields" etc.

//call this func to resize a textbox to it's content height
function AutoResize(elem) {
	var scrollHeight = elem.scrollHeight;
	if (scrollHeight > elem.clientHeight > 0 && elem.clientHeight < 350) {
		elem.style.height = (scrollHeight + 6) + "px";
	}
}

//call this func to resize editable ifram to it's content height
function AutoResizeEditableIframe(bodyObj) {
	var scrollHeight = bodyObj.scrollHeight;
	if (scrollHeight > bodyObj.clientHeight) {
		if (bodyObj.clientHeight < 350) {
			if (scrollHeight > 350) scrollHeight = 350;
			if (bodyObj.scrollHeight < 350)
				bodyObj.style.overflowY = 'hidden'; //to prevent annoying flickering
			bodyObj.style.height = (scrollHeight + 6) + "px";
		}
		else
			bodyObj.style.overflowY = 'auto';
	}
}

//Important! pass an ARRAY OF ARRAYS into "postData", like this [[key1,value1],[key2,value2]]
function RedirectAndSendPost(url, postData) {
	var strHtml = '<form action="' + url + '" method="post">';
	for (var i=0; i< postData.length; i++) {
		strHtml += '<input name="' + postData[i][0] + '" value="' + postData[i][1] + '" />';
	}
	strHtml += "</form>"

	var form = $(strHtml);
	$('body').append(form);
	form.submit();
}

function fetchAndRenderHtml(url, elementToReplace) {
	fetch(url)
		.then(response => response.ok ? response.text() : Promise.reject(response))
		.then(text => {
			let div = document.createElement('div');
			div.innerHTML = text;
			elementToReplace.replaceWith(div);
		});
}

function IsFF() {
	window.isFirefox ||= navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
	return window.isFirefox;
}

function ExpandYoutubeAndVimeo(selector) {
	$(selector).find("a").each(function () {
		if (this.href.indexOf("youtu.be") > -1 || this.href.indexOf("youtube.com") > -1) {
			var el = this;
			$.getJSON("https://www.youtube.com/oembed?url=" + this.href + "&format=json&maxwidth=700&maxheight=400", function (data) {
				el.insertAdjacentHTML('beforeBegin', data.html + "<br>");
				el.parentElement.removeChild(el);
			});
		}
		else if (this.href.indexOf("vimeo.com") > -1) {
			var el = this;
			$.getJSON("https://vimeo.com/api/oembed.json?url=" + this.href + "&maxwidth=700&maxheight=400", function (data) {
				el.insertAdjacentHTML('beforeBegin', data.html + "<br>");
				el.parentElement.removeChild(el);
			});
		}
	});
}

function DecodeHtml(str) {
	var element = document.createElement('div');
	element.innerHTML = str;
	return element.innerText || element.textContent;
}

function getQueryString() {
	var result = {}, queryString = location.search.substring(1),
		re = /([^&=]+)=([^&]*)/g, m;

	while (m = re.exec(queryString)) {
		if (result[decodeURIComponent(m[1])]) //already present in the dictionary - means it's an "array" query string, like url?a=1&a=2&a=3
		{
			var existingVal = result[decodeURIComponent(m[1])];
			if (existingVal.constructor === Array) //existing val is already an array
				existingVal.push(decodeURIComponent(m[2]))
			else {
				var arr = [];
				arr.push(result[decodeURIComponent(m[1])]);
				arr.push(decodeURIComponent(m[2]));
				result[decodeURIComponent(m[1])] = arr;
			}
		}
		else
			result[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
	}

	return result;
}

function InitUserBox(boxid, onSelectHandler, autocompleteUrl) {
	$('#' + boxid + '_txt').destroyautocomplete(); //kill exisitng autocomplete
	$('#' + boxid + '_txt').
		autocomplete(
			autocompleteUrl,
			{
				delay: 500,
				onItemSelect: function (li) { var userId = li.extra[0]; $('#' + boxid).val(userId); eval(onSelectHandler); },
				onClear: function () { $('#' + boxid).val(""); },
				onChange: function () { $('#' + boxid).val(""); }
			});
}

function HideInlineImgThunmbsAndAddLink() { //used in KB article view and Ticket view
	$('#body img, .commentBody img').not("a.attachments > img").each(function (index) { //select all inline images (then filter the ones already been wrapped in <A>)
		var m = this.src.match(/\/file\/get\/(\d+)/i);
		if (m) {
			$(this).wrap("<a href='" + this.src + "' class='imgLink' target='_blank'></a>"); //wrap with links
			var attId = m[1];
			$('#lnkFile' + attId).remove();
		}
	});
}

var Utils = { //just to organize it in namespace, so in other scripts we see where the function came from
	formatDateLocale: function (strDate, withTime = true) { //reformats date string in current helpdesk-culture defined in "globalLang"
		if (!strDate.length) return "";
		if (withTime)
			return new Date(strDate).toLocaleString(globalLang, { year: 'numeric', month: 'numeric', day: 'numeric', hour: 'numeric', minute: '2-digit' });		
		else
			return new Date(strDate + "T00:00").toLocaleDateString(globalLang);
	},

	padNumber: function (num, size) {
		var sNum = "" + num;
		var s = "000000000" + num;
		return s.substr(s.length - Math.max(size, sNum.length)); //in case the number is longer than "size"
	},

	addCopyButton: function () {
		var elements = document.getElementsByClassName('withCopyBtn');
		for (var i = 0; i < elements.length; i++) {
			var element = elements[i];
			var onclickHandler = (function () {
				return function () {
					Utils.copyToClipboard(this);
				};
			})(element);

			var sibling = element.nextElementSibling;
			if (sibling && sibling.classList.contains('copyBtn')) {
				// the button already exists, check the onclick handler (special case for usertooltip)
				if (typeof sibling.onclick !== 'function') {
					sibling.onclick = onclickHandler;
				}
				continue;
			}

			var copyBtn = document.createElement('a');
			copyBtn.href = "javascript:void(0);";
			copyBtn.title = "Copy to clipboard";
			copyBtn.innerHTML = '<i class="fa fa-files-o" aria-hidden="true"></i>';
			copyBtn.classList.add("grey");
			copyBtn.classList.add("copyBtn");
			copyBtn.style.marginLeft = "3px";
			copyBtn.onclick = onclickHandler;
			element.parentNode.insertBefore(copyBtn, element.nextSibling);
		}
	},

	copyToClipboard: function ( buttonElement) {
		var el = buttonElement.previousSibling;
		var text = el.tagName.toLowerCase() === 'input' ? el.value : el.textContent;

		navigator.clipboard.writeText(text)
			.then(() => {
				// Change the icon to a checkmark
				buttonElement.querySelector('i.fa').classList.replace('fa-files-o', 'fa-check');

				// Optional: Change back to clipboard icon after a delay
				setTimeout(() => {
					buttonElement.querySelector('i.fa').classList.replace('fa-check', 'fa-files-o');
				}, 2000); // Change back after 2 seconds
			})
			.catch(err => {});
	}
}

function updateQueryStringParameter(uri, key, value) {
	var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
	var separator = uri.indexOf('?') !== -1 ? "&" : "?";
	if (uri.match(re)) {
		return uri.replace(re, '$1' + key + "=" + value + '$2');
	}
	else {
		return uri + separator + key + "=" + value;
	}
}

var gridPopup = new function () {

	var currentCb = null;
	var onMoveCallback_ = null;
	var isRtl = document.body.dir == 'rtl';

	this.MovePopup = function (elem) {
		var selectedRowsCount = $(".cb:checked").not(".cbAll").length;
		var popup = $("#bulk-actions-popup");

		if (selectedRowsCount == 0) { popup.fadeOut(100); currentCb = null; return; } //nothing is selected, hiding
		else if (selectedRowsCount == 1) { $("li.multiple").hide(); } //single ticket selected, hide bulk actions
		else { $("li.multiple").fadeIn(); } //more than one ticket is selected, show every action

		//always recalculate horizontal position
		if(isRtl)
			popup.css("left", $(elem).offset().left + 15);
		else
			popup.css("right", $(window).width() - $(elem).offset().left + 15);

		if (elem.checked) { //do not move popup to the unchecked element
			popup.animate({ top: $(elem).offset().top - 24 }, 100);
		}
			//current cb was unchecked, we should move away somewhere
		else if (!elem.checked && $(elem).get(0) === $(currentCb).get(0)) {
			//at this point we have at least one other checked checkbox
			//findin the closest checked element; index of the current CB in array of all CBs
			var curIndex = $.inArray($(elem)[0], $(".cb"));
			//indexes of all checked CBs
			var checked = $(".cb").map(function (i, elem) { if (elem.checked) return i; });
			var closest = FindClosestNumber(checked, curIndex);
			//recursively moving
			this.MovePopup($(".cb")[closest]);
			return;
		}
		else { return; }

		currentCb = elem;
		popup.fadeIn(50);

		if (onMoveCallback_) onMoveCallback_(); //calback
	}

	this.ResetCurrentCb = function () { currentCb = null; }

	this.AttachToTable = function ($tableObj, onShowMoveCallback) {

		onMoveCallback_ = onShowMoveCallback;

		$tableObj.on("click", ".cb", function (event) {
			var selectedRows = $(".cb:checked").not(".cbAll");
			//if none or just one row is selected, no need to do anything special 
			if (event.shiftKey && selectedRows.length > 1 && this.checked) {
				//now handle the shift key for multiple rows (only for checking for now, not unchecking)
				var allRows = $(".cb");
				var curIndex = allRows.index(this);
				var selectedIndexes = allRows.map(function (i, elem) { if (elem.checked && i != curIndex) return i; });
				var closest = FindClosestNumber(selectedIndexes, curIndex);

				//take everything inbetween the checked rows and check them too
				allRows.slice(Math.min(curIndex, closest), Math.max(curIndex, closest) + 1).prop('checked', 'checked').closest("tr").addClass("highlight");
			} else {
				$(this).closest("tr").toggleClass("highlight"); //highlight table row when checkbox clicked
			}
			gridPopup.MovePopup(this);
		});

		$tableObj.on("click", ".cbAll", function () { //highlight all / de-highlight all
			if ($(this).prop("checked")) {
				$(".cb").prop('checked', true);
				$tableObj.find("tr").has(".cb").addClass("highlight");
			}
			else {
				$(".cb").prop('checked', false);
				$tableObj.find("tr").has(".cb").removeClass("highlight");
				$("#bulk-actions-popup").fadeOut(100);
				gridPopup.ResetCurrentCb();
			}
			gridPopup.MovePopup(this);
		});
	}

	function FindClosestNumber(array, desiredNumber) {
		var nearest = -1;
		var bestDistanceFoundYet = Number.MAX_VALUE;
		// We iterate on the array...
		for (var i = 0; i < array.length; i++) {
			// if we found the desired number, we return it.
			if (array[i] == desiredNumber) {
				return array[i];
			} else {
				// else, we consider the difference between the desired number and the current number in the array.
				var d = Math.abs(desiredNumber - array[i]);
				if (d < bestDistanceFoundYet) {
					// For the moment, this value is the nearest to the desired number...
					nearest = array[i];
					bestDistanceFoundYet = d;
				}
			}
		}
		return nearest;
	}
}

function ProcessCtrlEnter(e, callback, withShiftCallback) {
	var evt = e ? e : window.event;
	if (evt.ctrlKey || evt.metaKey) { // ctrl or cmd for macs
		var keyCode = evt.keyCode ? evt.keyCode : evt.which;
		if (keyCode == 13) {
			if (evt.shiftKey && withShiftCallback)
				withShiftCallback();
			else
				callback();
			return false;
		}
		else
			return true;
	}
	else
		return true;
}

$.fn.toggleFade = function(show) {
	if (show) {
		$(this).fadeIn(800);
	}
	else {
		$(this).fadeOut(800);
	}
}
$.fn.fadeRemove = function () {
	var el = this;
	return new Promise(function (resolve) {
		$(el).fadeOut(300, function () { $(this).remove(); resolve(); })
	});
}

function IsSmartPhone() { //https://stackoverflow.com/a/24600597/56621
	if (typeof window.isSmartPhone !== 'undefined') return window.isSmartPhone;
	var check = false;
	if (/Mobi|Android/i.test(navigator.userAgent)) check = true;
	window.isSmartPhone = check;
	return check;
}

$(function () {
	if (!IsSmartPhone()) {
		//top announcement bar
		$('.announcementbar').each(function () {
			if ($.cookie("announcement" + $(this).data("name")) == null) { //show only if "hide" cookie is not set
				var conditionFunction = $(this).data("conditionfunction");
				if (conditionFunction == null || (window[conditionFunction] && window[conditionFunction]() === true))
					$(this).show();
			}
		});
		$('.announcementbar a.announcementClose').click(function () {
			var $announcementdiv = $(this).parent();
			$announcementdiv.hide();
			$.cookie("announcement" + $announcementdiv.data("name"), "true", { expires: $announcementdiv.data("expiredays") });
		});

		Utils.addCopyButton();
	}

	//init "location" custom fields
	if ($(".locationCF").length) {
		InitLocationFields();
	}

	//mimic "placeholder" style for <select>
	HtmlSelectPlaceholdersUtil();

	// renew "time ago strings" 
	setInterval(function () {
		var elems = document.querySelectorAll("[data-ago-date]");
		for (var i = 0; i < elems.length; i++) {
			var el = elems.item(i);
			var date = el.getAttribute("data-ago-date");
			var dateAgo = timeSince(new Date(date));
			if (dateAgo)
				el.innerText = dateAgo;
			else
				el.removeAttribute("data-ago-date");
		}
	}, 60 * 1000);
});

window.addEventListener("load", function () { //don't bother the server via signalr until everything is loaded, also this breaks unittests in headless mode for some reasno
	//init global signalr connection!!
	//no signalr? (user is non tech, script was not included) - return
	if (typeof signalR === 'undefined' || !signalR) return;

	window._signalrConnection = new signalR.HubConnectionBuilder()
		.withUrl(globalRootAppUrl + "hdHub")
		.configureLogging("none")
		.withAutomaticReconnect([20000, 30000, 60000, 120000])
		.build();

	_signalrConnection.on("browserPush", function (title, body, ticketId) {
		showDesktopNotification(ticketId, title, body);
	});

	// Start the connection, save promise in global var
	window._signalrAfterConnect = _signalrConnection.start()
		.then(function () { SetDefaultXHRHeader("signalrConnectionId", _signalrConnection.connection.connectionId) }); //add signalr connectionID to all ajax headers

	_signalrConnection.onreconnected(function (connectionId) { SetDefaultXHRHeader("signalrConnectionId", connectionId) }); //add header after reconnecting too

	window._signalrAfterConnect.catch(function () { }); //swallow error lesser log spam
});

function SetDefaultXHRHeader(name, value) { //add global header to all XHR requests
	//override "open"
	window.xhrOrigOpen ||= XMLHttpRequest.prototype.open;
	XMLHttpRequest.prototype.open = function (method, url, async, user, password) {
		window.xhrOrigOpen.apply(this, arguments);
		if (url.indexOf(window.location.host) > -1) //only if it's a local url (so extentions work, see #1588)
			this.setRequestHeader(name, value); //add header
	};
}

function HtmlSelectPlaceholdersUtil() {
	$("select.mimicplaceholder").each(function () {
		if (!this.value || this.value == "0" || this.value == "-1") { //nothing is selected
			this.classList.add('greyer'); //make it look like placeholder
			this.addEventListener("click", selectClicked); //remove style on click
		}
		else { this.options[0].text = ''; }
	});

	function selectClicked(event) {
		event.target.classList.remove('greyer');
		if (event.target.options && event.target.options.length 
			&& event.target.options[0].text && !event.target.options[0].disabled) { this.options[0].text = ''; } //empty 1st option text
		event.target.removeEventListener("click", selectClicked);
	}
}

function InitLocationFields() {
	if (!window.gMapsApiKey) return;
	if ($(".locationCF").length) {
		// "location" custom fields found on page, lets connect google JS library
		$.ajaxSetup({ cache: true }); // so $.getScript does no do cache
		$.getScript('https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places&key=' + window.gMapsApiKey, function () {
			$('.locationCF').each(function () {
				autocomplete = new google.maps.places.Autocomplete(this, { types: ['geocode'] });
			});
		});
	}
}

$(function () {
	var code = null;
	$("#tbQuery").bind("keypress", function (e) {
		code = (e.keyCode ? e.keyCode : e.which);
		if (code == 13) {
			DoSearch();
			e.preventDefault();
		}
	});
});

var recentLoaded = false;

function ShowRecents() {
	var hidePopup = function () {
		if ($('#divRecent').is(':visible')) {
			$('#divRecent').hide();
		}
		$(document).unbind('click.recents', hidePopup);
		$(document).unbind('keydown.recents', hidePopup);
	};

	if ($('#divRecent').is(':visible')) { //already shown?
		hidePopup();
		return;
	}

	$(document).unbind('click.recents', hidePopup); //to make links clickable

	var pos = $('#btnUser').offset();
	$('#divRecent').show().css({ right: 30, top: pos.top + 40 });

	setTimeout(function () {
		$(document).bind('click.recents', hidePopup);
		$(document).bind('keydown.recents', function (e) { if (e.keyCode == 27) hidePopup(); });
	}, 500);

	if (!recentLoaded) {
		$.get(
			globalRootAppUrl + "User/GetRecentlyViewedTickets",
			function (data) {
				$("#divRecent").get(0).innerHTML = data;
				recentLoaded = true;
			});
	}
}

function showDesktopNotification(ticketId, title, body) {
	if (typeof Notification === 'undefined') return;
	if (Notification.permission !== "granted") { Notification.requestPermission(); return; }

	try {
		var ntfy = new Notification(title, {
			icon: GetAbsolutePath(globalRootAppUrl) + document.querySelector("link[rel=icon]").getAttribute('href'),
			body: body,
			tag: ticketId
		});
		ntfy.onclick = function (e) {
			e.preventDefault();
			if (window.location.href.indexOf(ticketId) > -1) { //this ticket is already open, just focus on the tab
				parent.focus(); window.focus();
			}
			else
				window.open(GetAbsolutePath(globalRootAppUrl) + "Ticket/" + ticketId, '_blank');
		}
	}
	catch (ex) { } //mobile chorme https://stackoverflow.com/questions/29774836/failed-to-construct-notification-illegal-constructor
}

function DoSearch(event) {
	document.location.href = globalRootAppUrl + "Tickets/Search?q=" + encodeURIComponent($("#tbQuery").val());
}

function GetAbsolutePath(relativePath) {
	window.tmplink = window.tmplink || document.createElement("a"); //cache in a global var
	var link = window.tmplink;
	link.href = relativePath;
	return (link.protocol + "//" + link.host + link.pathname + link.search + link.hash);
}

var loadDeferredStyles = function () {
	var addStylesNode = document.getElementById("deferred-styles");
	if (!addStylesNode) return;
	var replacement = document.createElement("div");
	replacement.innerHTML = addStylesNode.textContent;
	document.body.appendChild(replacement)
	addStylesNode.parentElement.removeChild(addStylesNode);
};
var raf = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || window.msRequestAnimationFrame;
if (raf) raf(function () { window.setTimeout(loadDeferredStyles, 0); });
else window.addEventListener('load', loadDeferredStyles);

//input-date show calendar on focus
const dateinputs = document.querySelectorAll("input[type=date],input[type=datetime-local]");
dateinputs.forEach(i => {
	//fix Firefox empty time bug
	if (IsFF() && i.type == 'datetime-local' && !i.value) { //datetime input with empty value? set to current date (on focus only), b/c firefox has no time picker and sets whole input to null
		i.addEventListener('focus', () => {
			if (!i.value)
				i.value = new Date().toISOString().slice(0, -8);
		});
	}

	const oldType = i.type;
	if (!i.value && i.placeholder) i.type = 'text'; //switch type to text to show placeholder
	i.addEventListener('focus', () => { i.type = oldType; if (i.checkValidity()) i.showPicker(); }); //show picker on focus (only if value is valid, otherwise HTML5 validation popup is hidden under the popup)
});

//replaces "xxx:blah" with clickable links
//supports custom schemas, like "skype:xxx" or "ftp:" or "tel:xxx"
function convertToLink(text) {
	text = (text || "").trim();
	
	return text.replace(/(^|\s)([a-z]+:[\w\-\?:@=$%*\.\&/]+)(?=$|\s)/g, "$1<a href='$2' target='_blank'>$2</a>");
	/*					 ^^^^^^										- whitespace or BOL
	 *						   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^		- match schema like "ftp:xxx" or "skype:xxx" or "sip:xxx" or even "http:xxx" where "xxx" are characters allowed in an URL
	 *														^^^^^^^	- lookahead check - ends with space or EOL
	*/
}

function timeSince(date) {
	var now_utc = new Date(new Date().toUTCString().slice(0, -4));

	var seconds = Math.floor((now_utc - date) / 1000);

	var interval = seconds / 43200; //12 hours
	if (interval > 1) {
		return;
	}
	interval = seconds / 3600;
	if (interval > 1) {
		return Math.floor(interval) + ' ' + _langStrings.HoursAgo;
	}
	interval = seconds / 60;
	if (interval > 1) {
		return Math.floor(interval) + ' ' + _langStrings.MinutesAgo;
	}
	return Math.floor(seconds) + ' ' + _langStrings.SecondsAgo;
}

function InitDependentFields() {
	$("select[data-parentId] option[value!='']:not([selected])").hide().prop("disabled", true); //hide/disable all nonempty/nonselected options in dependent fields
	$("select[name^=cf]:not([multiple])").change(function () {	
		$("select[data-parentId=" + this.name.replace("cf", "") + "] option[value!='']").hide().prop("disabled", true).removeAttr("selected"); //hide/disable all options in child selects
		if (!this.value) return;
		$("select[data-parentId] option[data-parentOptionId=" + this.value + "]").show().prop("disabled", false); //show/enable dependent options
	});
	//now take care of default (preselected) options for parent
	$("select[name^=cf]:not([multiple])")
		.filter(function () { return this.value; }) //has non-empty value. means a default value is set
		.each(function () {
			$("select[data-parentId] option[data-parentOptionId=" + this.value + "]").show().prop("disabled", false); //show/enable dependent options
		});
}

//track when window/tab becomes hidden (user switches to another tab or alt-tab to another window) https://stackoverflow.com/a/38710376/56621
function onVisibilityChange(callback) {
	var visible = true;

	function focused() {
		if (!visible)
			callback(visible = true);
	}

	function unfocused() {
		if (visible)
			callback(visible = false);
	}

	// Standards:
	if ('hidden' in document) {
		document.addEventListener('visibilitychange',
			function () { (document.hidden ? unfocused : focused)() });
	}
	if ('mozHidden' in document) {
		document.addEventListener('mozvisibilitychange',
			function () { (document.mozHidden ? unfocused : focused)() });
	}
	if ('webkitHidden' in document) {
		document.addEventListener('webkitvisibilitychange',
			function () { (document.webkitHidden ? unfocused : focused)() });
	}
	if ('msHidden' in document) {
		document.addEventListener('msvisibilitychange',
			function () { (document.msHidden ? unfocused : focused)() });
	}
	// All others:
	window.onpageshow = window.onfocus = focused;
	window.onpagehide = window.onblur = unfocused;
};

function isDarkMode() {
	return window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches;
}

const _id = id => document.getElementById(id); //just a shorthand